## halide 13.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.20)
project(Halide
        VERSION 13.0.2
        DESCRIPTION "Halide compiler and libraries"
        HOMEPAGE_URL "https://halide-lang.org")

enable_testing()

##
# Set up project-wide properties
##

# Make our custom helpers available throughout the project via include().
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
include(HalideGeneratorHelpers)
include(MakeShellPath)
include(CMakeDependentOption)

# Build Halide as a shared lib by default, but still honor command-line settings.
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Warn if the user did not set a build type and is using a single-configuration generator.
get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (NOT IS_MULTI_CONFIG AND NOT CMAKE_BUILD_TYPE)
    message(WARNING "Single-configuration generators require CMAKE_BUILD_TYPE to be set.")
endif ()

# Windows has file name length restrictions and lacks an RPATH mechanism.
# We work around this by setting a path max and putting all exes / dlls in
# the same output directory.
if (CMAKE_SYSTEM_NAME MATCHES "Windows")
    set(CMAKE_OBJECT_PATH_MAX 260)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")

    message(STATUS "Windows: setting CMAKE_OBJECT_PATH_MAX to ${CMAKE_OBJECT_PATH_MAX}")
endif ()

# Export all symbols on Windows to match GCC/Clang behavior on Linux/macOS
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Require standard C++17
if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)
elseif(CMAKE_CXX_STANDARD LESS 17)
    message(FATAL_ERROR "Halide requires C++17 or newer")
endif()

# Build Halide with ccache if the package is present
option(Halide_CCACHE_BUILD "Set to ON for a ccache enabled build" OFF)
if (Halide_CCACHE_BUILD)
    find_program(CCACHE_PROGRAM ccache)
    if (CCACHE_PROGRAM)
        # TODO: ccache recommends setting CCACHE_SLOPPINESS=pch_defines,time_macros to
        # enable precompiled header caching. Our timing found it slightly faster with
        # just CCACHE_SLOPPINESS=pch_defines, so that's what we're using. Maybe revisit
        # if issues occur (but we don't use any of the time macros so should be irrelevant).
        set(Halide_CCACHE_PARAMS CCACHE_CPP2=yes CCACHE_HASHDIR=yes CCACHE_SLOPPINESS=pch_defines
            CACHE STRING "Parameters to pass through to ccache")
        set(CMAKE_C_COMPILER_LAUNCHER ${CMAKE_COMMAND} -E env ${Halide_CCACHE_PARAMS} ${CCACHE_PROGRAM})
        set(CMAKE_CXX_COMPILER_LAUNCHER ${CMAKE_COMMAND} -E env ${Halide_CCACHE_PARAMS} ${CCACHE_PROGRAM})
        message(STATUS "Enabling ccache usage for building.")
    else ()
        message(FATAL_ERROR "Unable to find the program ccache. Set Halide_CCACHE_BUILD to OFF")
    endif ()
endif ()

##
# Import dependencies
##

add_subdirectory(dependencies)

##
# Add source directories
##

add_subdirectory(src)
add_subdirectory(tools)

##
# Add tests, tutorials, etc. if we're not being imported into another CMake project.
##

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    option(WITH_TESTS "Build tests" ON)
    if (WITH_TESTS)
        message(STATUS "Building tests enabled")
        add_subdirectory(test)
    else ()
        message(STATUS "Building tests disabled")
    endif ()

    option(WITH_PYTHON_BINDINGS "Build Python bindings" ON)
    if (WITH_PYTHON_BINDINGS)
        if (Halide_ENABLE_RTTI AND Halide_ENABLE_EXCEPTIONS)
            message(STATUS "Building Python bindings enabled")
            add_subdirectory(python_bindings)
        else ()
            if (NOT Halide_ENABLE_RTTI)
                message(WARNING "Building Python bindings disabled: must compile with RTTI")
            endif ()
            if (NOT Halide_ENABLE_EXCEPTIONS)
                message(WARNING "Building Python bindings disabled: must compile with exceptions")
            endif ()
            set(WITH_PYTHON_BINDINGS OFF CACHE BOOL "Build Python bindings" FORCE)
        endif ()
    else ()
        message(STATUS "Building Python bindings disabled")
    endif ()

    option(WITH_TUTORIALS "Build tutorials" ON)
    if (WITH_TUTORIALS)
        message(STATUS "Building tutorials enabled")
        add_subdirectory(tutorial)
    else ()
        message(STATUS "Building tutorials disabled")
    endif ()

    option(WITH_DOCS "Build documentation" OFF)
    if (WITH_DOCS)
        message(STATUS "Building docs enabled")
        add_subdirectory(doc)
    else ()
        message(STATUS "Building docs disabled")
    endif ()

    option(WITH_UTILS "Build utils" ON)
    if (WITH_UTILS)
        message(STATUS "Building utils enabled")
        add_subdirectory(util)
    else ()
        message(STATUS "Building utils disabled")
    endif ()

    add_subdirectory(packaging)

    add_custom_target(distrib
                      COMMAND ${CMAKE_COMMAND} -E echo "\\'distrib\\' is not available under CMake. Use \\'package\\' instead.")

    if (TARGET clang-format AND NOT WIN32)
        add_custom_target(format COMMAND
                          find
                          "${Halide_SOURCE_DIR}/apps"
                          "${Halide_SOURCE_DIR}/src"
                          "${Halide_SOURCE_DIR}/tools"
                          "${Halide_SOURCE_DIR}/test"
                          "${Halide_SOURCE_DIR}/util"
                          "${Halide_SOURCE_DIR}/python_bindings"
                          -name *.cpp -o -name *.h -o -name *.c |
                          xargs $<TARGET_FILE:clang-format> -i -style=file)
    endif ()
endif ()

=== debian/changelog ===
halide (13.0.2-1) unstable; urgency=medium

  * Update to latest upstream release, drop upstreamed patches.
  * Another attempt at fixing RISC-V / etc LLD-related build failures.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Fri, 10 Dec 2021 22:02:48 +0300

=== debian/control ===
Source: halide
Section: devel
Priority: optional
Maintainer: Roman Lebedev <lebedev.ri@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, llvm-13,
               llvm-13-dev, clang-13, libclang-13-dev,
               lld-13 [!powerpc !mips64el !ppc64 !riscv64],
               liblld-13-dev, libomp-13-dev, libgl-dev, zlib1g-dev, libjpeg-dev,
               libpng-dev, doxygen, libxml2-dev, libopenblas-dev
Standards-Version: 4.6.0
Homepage: https://halide-lang.org/
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/halide/-/tree/debian
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/halide.git -b debian
Rules-Requires-Root: no

Package: libhalide13-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast, portable computation on images and tensors
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 Halide currently targets:
  * CPU architectures: X86, ARM, MIPS, Hexagon, PowerPC, RISC-V
  * Operating systems: Linux, Windows, macOS, Android, iOS, Qualcomm QuRT
  * GPU Compute APIs: CUDA, OpenCL, OpenGL Compute Shaders, Apple Metal,
                     Microsoft Direct X 12
 Rather than being a standalone programming language,
 Halide is embedded in C++. This means you write C++ code that builds
 an in-memory representation of a Halide pipeline using Halide's C++ API.
 You can then compile this representation to an object file,
 or JIT-compile it and run it in the same process.

Package: libhalideaot13-0
Architecture: all
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends},
         libllvm13
Description: fast, portable computation on images and tensors (virtual library)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 Software that uses halide can either rely on just-in-time compilation,
 in which case it runtime-depends on/links to libhalide, or it can be compiled
 ahead of time, when building the software, in which case it does not strictly
 depend on halide. Former software should depend on this package instead, to
 make it obvious which software needs to be rebuilt with newer halide versions.
 .
 This is an empty package.

Package: libhalide13-0-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhalide13-0 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends},
         llvm-13-dev
Description: fast, portable computation on images and tensors -- Development files
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains the files necessary to develop against libhalide.

Package: libhalide13-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast, portable computation on images and tensors (documentation)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains doxygen API documentation and tutorials.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

HALIDE_VERSION = 13

HALIDE_SOVERSION = 0

LLVM_VERSION = 13

WITH_LTO = ON
WITH_TESTS = ON
WITH_PGO = ON
WITH_LLD = ON

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Respect nocheck.
	WITH_TESTS = OFF
	# If we aren't allowed to run tests, then certainly no PGO either.
	WITH_PGO = OFF
endif

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH),powerpc)
	# No LLD.
	WITH_LLD = OFF
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
endif

ifeq ($(DEB_HOST_ARCH),ppc64)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
endif

ifeq ($(DEB_HOST_ARCH),riscv64)
	# Linker relaxation is not implemented, need to compile with -mno-relax,
	# but then can't link to libs that aren't compiled with -mno-relax.
	WITH_LLD = OFF
	# Constrained builders, let's not bother with LTO for now.
	WITH_LTO = OFF
	# There is no LLVM compiler-rt library on riscv64, so PGO is impossible.
	WITH_PGO = OFF
endif

CC = clang-$(LLVM_VERSION)
CXX = clang++-$(LLVM_VERSION)

SOURCE_DIR = $(CURDIR)

BUILD_STAGE ?= 1
STAGE_COMPILE_FLAGS ?=

CFLAGS = -g $(STAGE_COMPILE_FLAGS)

ifneq ($(WITH_LLD),OFF)
	CFLAGS += -fuse-ld=lld-$(LLVM_VERSION)
endif

CXXFLAGS = $(CFLAGS)

PROFILE_DIR = $(SOURCE_DIR)/build-profile
PROFILE_TMP_DIR = $(PROFILE_DIR)/raw
LLVM_PROFILE_FILE = "$(PROFILE_TMP_DIR)/stage-$(BUILD_STAGE)-%p-%m.profraw"
PROFILE = $(PROFILE_DIR)/default.profdata

BUILD_DIR_PREFIX = $(SOURCE_DIR)/build

STAGE_BUILD_DIR_PREFIX = $(BUILD_DIR_PREFIX)/stage-$(BUILD_STAGE)
BUILD_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide
INSTALL_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide-install
APPS_BUILD_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide-test-apps

%:
	dh $@ --buildsystem=cmake+ninja

perform_stage_build:
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_configure --sourcedir=$(SOURCE_DIR) --builddir=$(BUILD_DIR) -- \
	-DCMAKE_C_COMPILER=$(CC) \
	-DCMAKE_CXX_COMPILER=$(CXX) \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=$(WITH_LTO) \
	-DCMAKE_POSITION_INDEPENDENT_CODE=ON \
	-DHalide_ENABLE_RTTI=ON \
	-DHalide_ENABLE_EXCEPTIONS=ON \
	-DWITH_PYTHON_BINDINGS=OFF \
	-DHalide_REQUIRE_LLVM_VERSION=$(LLVM_VERSION) \
	-DLLVM_DIR=/usr/lib/llvm-$(LLVM_VERSION)/lib/cmake/llvm \
	-DHalide_SHARED_LLVM=ON \
	-DTARGET_WEBASSEMBLY=OFF \
	-DWITH_TESTS=$(WITH_TESTS) \
	-DWITH_DOCS=ON \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)/ \
	-DHalide_INSTALL_PLUGINDIR=lib/$(DEB_HOST_MULTIARCH)/halide$(HALIDE_VERSION)/ \
	-DCMAKE_INSTALL_INCLUDEDIR=include/halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_CMAKEDIR=lib/$(DEB_HOST_MULTIARCH)/cmake/Halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_HELPERSDIR=lib/$(DEB_HOST_MULTIARCH)/cmake/HalideHelpers$(HALIDE_VERSION)/ \
	-DCMAKE_INSTALL_BINDIR=lib/$(DEB_HOST_MULTIARCH)/halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_TOOLSDIR=src/halide$(HALIDE_VERSION)/ \
	-DCMAKE_INSTALL_DOCDIR=share/doc/halide$(HALIDE_VERSION)/

	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_build --builddir=$(BUILD_DIR)

ifneq ($(WITH_TESTS),OFF)
	# WARNING: running multiple halide tests in parallel is unsupported!
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) ctest -j1 --test-dir $(BUILD_DIR)
endif

	dh_auto_install --builddir=$(BUILD_DIR) --destdir=$(INSTALL_DIR)

	rm -rf $(BUILD_DIR)

ifneq ($(WITH_TESTS),OFF)
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_configure --sourcedir=$(SOURCE_DIR)/apps/ --builddir=$(APPS_BUILD_DIR) -- \
	-DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) \
	-DCMAKE_C_FLAGS="$(CFLAGS)" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release -DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
	-DENABLE_APPS_HANNK=OFF \
	-DHalide_DIR=$(INSTALL_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Halide$(HALIDE_VERSION)/ \
	-DHalideHelpers_DIR=$(INSTALL_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/HalideHelpers$(HALIDE_VERSION)/

	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_build --builddir=$(APPS_BUILD_DIR)

	# WARNING: running multiple halide tests in parallel is unsupported!
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) ctest -j1 --test-dir $(APPS_BUILD_DIR)

	rm -rf $(APPS_BUILD_DIR)
endif

override_dh_auto_configure:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_auto_build:
ifneq ($(WITH_PGO),OFF)
	BUILD_STAGE=0 STAGE_COMPILE_FLAGS="-fprofile-generate -Xclang -mllvm -Xclang -vp-counters-per-site=2.0" $(MAKE) -f debian/rules perform_stage_build
	rm -rf $(BUILD_DIR_PREFIX)
	llvm-profdata-$(LLVM_VERSION) merge -output=$(PROFILE) $(PROFILE_TMP_DIR)
	rm -rf $(PROFILE_TMP_DIR)

	# FIXME: why doesn't this work?
	# BUILD_STAGE=<placeholder> STAGE_COMPILE_FLAGS="-fprofile-use=$(PROFILE) -fcs-profile-generate -Xclang -mllvm -Xclang -vp-counters-per-site=15.0" $(MAKE) -f debian/rules perform_stage_build
	# rm -rf $(BUILD_DIR_PREFIX)
	# rm $(PROFILE)
	# llvm-profdata-$(LLVM_VERSION) merge -output=$(PROFILE) $(PROFILE_TMP_DIR)
	# FIXME: should we merge the non-CS profile with CS profile? how?
	# rm -rf $(PROFILE_TMP_DIR)

	STAGE_COMPILE_FLAGS="-fprofile-use=$(PROFILE)" $(MAKE) -f debian/rules perform_stage_build
else
	$(MAKE) -f debian/rules perform_stage_build
endif

override_dh_auto_test:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_auto_install:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_install:
	dh_install --sourcedir=$(INSTALL_DIR)
